	.686
	.model flat, stdcall
	option casemap :none
	
	include \masm32\include\ntdll.inc
	includelib \masm32\lib\ntdll.lib

	include \masm32\include\kernel32.inc
	includelib \masm32\lib\kernel32.lib

.code
CompareStringSensitive proc uses ebx UnicodeString:PUNICODE_STRING, AnsiString:PSTR, StringLength:ULONG
	mov ebx,StringLength
	mov edx,UnicodeString
	lea eax,[ebx*2]
	assume edx:PUNICODE_STRING
	cmp [edx]._Length,ax
	jne Exit
	mov ecx,AnsiString
	mov edx,[edx].Buffer
@@:
	movzx eax,byte ptr [ecx + ebx - 1]
	cmp word ptr [edx + ebx*2 - 2],ax
	jne Exit
	dec ebx
	jnz @b
	xor eax,eax
Exit:
	ret
CompareStringSensitive endp

EnumObjects proc uses ebx esi edi ObName:PSTR, ObNameLength:ULONG, PID:HANDLE, Callback:PVOID, Context:PVOID
Local S1ze:ULONG, ObInfo:PVOID
Local Buffer[2*sizeof(SYSTEM_HANDLE_INFORMATION)]:BYTE
	xor eax,eax
	lea ecx,S1ze
	mov ObInfo,eax
	invoke ZwQueryObject, Eax, ObjectAllTypesInformation, Eax, Eax, Ecx
	cmp eax,STATUS_INFO_LENGTH_MISMATCH
	jne Exit
	invoke ZwAllocateVirtualMemory, NtCurrentProcess, addr ObInfo, NULL, addr S1ze, MEM_COMMIT, PAGE_READWRITE
	test eax,eax
	mov edi,ObInfo
	jnz Exit
	invoke ZwQueryObject, Eax, ObjectAllTypesInformation, Edi, S1ze, Eax
	test eax,eax
	mov esi,OBJECT_ALL_TYPES_INFORMATION.NumberOfTypes[edi]
	jnz Qerr
	mov ebx,esi
	add edi,4
	assume edi:POBJECT_TYPE_INFORMATION
@@:
	invoke CompareStringSensitive, Edi, ObName, ObNameLength
	movzx ecx,[edi].TypeName._Length
	je Parse
	and ecx,NOT(3)
	mov edi,[edi].TypeName.Buffer
	lea edi,[edi + ecx + 4]
	dec esi
	jnz @b
	mov eax,STATUS_NOT_FOUND
Parse:
	push eax
	invoke ZwFreeVirtualMemory, NtCurrentProcess, addr ObInfo, addr S1ze, MEM_RELEASE
	pop eax
	sub ebx,esi	; ObjectTypeNumber
	test eax,eax
	jnz Exit
	inc ebx
L1:
	invoke ZwQuerySystemInformation, SystemHandleInformation, addr Buffer, sizeof(SYSTEM_HANDLE_INFORMATION)*2, addr S1ze
	cmp eax,STATUS_INFO_LENGTH_MISMATCH
	mov ObInfo,NULL
	jne Exit
	add S1ze,X86_PAGE_SIZE
	invoke ZwAllocateVirtualMemory, NtCurrentProcess, addr ObInfo, NULL, addr S1ze, MEM_COMMIT, PAGE_READWRITE
	test eax,eax
	jnz Exit
	invoke ZwQuerySystemInformation, SystemHandleInformation, ObInfo, S1ze, Eax
	test eax,eax
	mov esi,ObInfo
	jnz Qerr
	mov edi,D[esi]
	add esi,4
	.repeat
		assume esi:PSYSTEM_HANDLE_INFORMATION
		mov eax,PID
		.if ([Esi].ProcessId == Eax) && ([Esi].ObjectTypeNumber == Bl)
			movzx eax,[esi].Handle
			push Context
			push eax
			Call Callback
			test eax,eax
			jz Exit
			; STATUS_NOT_FOUND etc.
		.endif
		add esi,sizeof(SYSTEM_HANDLE_INFORMATION)
		dec edi
	.until Zero?
	mov eax,STATUS_NOT_FOUND
Exit:
	ret
Qerr:
	push eax
	invoke ZwFreeVirtualMemory, NtCurrentProcess, addr ObInfo, addr S1ze, MEM_RELEASE
	pop eax
	jmp Exit
EnumObjects endp

$Msg		CHAR "%wZ", 13, 10, 0

Clbk proc uses ebx esi edi Handle:HANDLE, Context:PVOID
Local Buffer[MAX_PATH]:CHAR
	invoke ZwQueryObject, Handle, ObjectNameInformation, addr Buffer, MAX_PATH, NULL
	.if !Eax
		invoke DbgPrint, addr $Msg, addr Buffer
	.endif
	mov eax,STATUS_NOT_FOUND
	ret
Clbk endp

$Ob		CHAR "File"
$File	CHAR "Obj.exe", 0

	assume fs:nothing
EP proc
Local File:OFSTRUCT
	invoke OpenFile, addr $File, addr File, OF_READ
	invoke EnumObjects, addr $Ob, 4, fs:[TEB.Cid.UniqueProcess], addr Clbk, 123H
	ret
EP endp
end EP